#pragma once

extern "C++" {
#include <gmpxx.h>
}
#include<string>
/*
Extension class for mpf_class2
by: Quincy Lam
mpf_class already implements:
- operator=
*/

class mpf_class2 : public mpf_class
{
    /*
    Wraps mpf_t in operator overloads
    Written by Quincy Lam
    Defining a copy constructor shall break bu_log
    */
public:

	mpf_class2(double d);
	mpf_class2(signed long sl);
	mpf_class2(signed si);
	mpf_class2(const mpf_class2& c);

	mpf_class2& operator+=(const mpf_class2& rhs);
    mpf_class2& operator+=(unsigned long rhs);
    mpf_class2& operator+=(double rhs);
    const mpf_class2 operator+(const mpf_class2& rhs) const;
    mpf_class2& operator-=(const mpf_class2& rhs);
    mpf_class2& operator-=(unsigned long rhs);
    mpf_class2& operator-=(double rhs);
    const mpf_class2 operator-(const mpf_class2& rhs) const;
    mpf_class2& operator*=(const mpf_class2& rhs);
    mpf_class2& operator*=(unsigned long rhs);
    mpf_class2& operator*=(double rhs);
    const mpf_class2 operator*(const mpf_class2& rhs) const;
    mpf_class2& operator/=(const mpf_class2& rhs);
    mpf_class2& operator/=(unsigned long rhs);
    mpf_class2& operator/=(double rhs);
    const mpf_class2 operator/(const mpf_class2& rhs) const;
    mpf_class2& operator=(const mpf_class2& rhs);
    mpf_class2& operator=(signed long rhs);
    mpf_class2& operator=(unsigned long rhs);
    mpf_class2& operator=(double rhs);
    bool operator==(const mpf_class2& rhs) const;
    bool operator!=(const mpf_class2& rhs) const;
    bool operator<(const mpf_class2& rhs) const;
    bool operator>(const mpf_class2& rhs) const;
    bool operator<=(const mpf_class2& rhs) const;
    bool operator>=(const mpf_class2& rhs) const;
    const mpf_class2 operator-() const;

    operator double() const;
    operator std::string() const;
    /*
    operator signed long() const;
    */
    static const long precision;
};
